#include <iostream>
#include <string>
#include "../Include/FileReader.h"
#include "../Include/FileHelper.h"
#include "../Include/NumberHelper.h"
#include "../Include/ScoreCalculator.h"
#include "../Include/PrintFrames.h"

using namespace std;

int main(int argc, char *argv[]) {
    if (argc < 2) {
        cerr << "Please provide a CSV formatted file.";
        return 0;
    }
    
    if (!FileHelper::FileExists(argv[1])) {
        cerr << "Filepath: " << argv[1] << " doesn't exist.";
        return 0;
    }
    
    string file = FileReader::GetFile(argv[1]);
    vector<int> rolls = NumberHelper::GetNumbers(file);
    
    PrintFrames::PrintHeader(rolls);
    PrintFrames::PrintValue(rolls);
    
    int score = ScoreCalculator::GetScore(rolls);
    cout << "Score: " << score << endl;
    
    return 0;
}
